找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1850|回复: 0

[每日一码] 打印AcDbLineTypeTableRecord线型定义引用的SHX文件名

[复制链接]

已领礼包: 13个

财富等级: 恭喜发财

发表于 2016-8-12 19:03:38 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×

问题:
I need to find a compiled shape file (shx) used by an AcDbLinetypeTableRecord class. How can I determine what shape a linetype uses?

解决方案:
If a line type uses a shx file it will reference an AcDbTextStyleTableRecord. Here is an example that prints the names of the shx file used by the ZIGZAG linetype in acad.lin.

  1. static void ASDKwbTEST(void)
  2. {
  3.    AcDbDatabase* pDb = curDoc()->database();
  4.   assert(pDb);
  5.   //get line type table
  6.   AcDbLinetypeTable *pLTTable ;
  7.   acdbOpenObject(pLTTable,pDb->linetypeTableId(),AcDb::kForRead);

  8.   AcDbLinetypeTableRecord *pLTRecord = NULL ;

  9.   AcDbObjectId objLTId ;
  10.   //pLTTable->getAt(_T("TRACKS"), objLTId) ;
  11.   pLTTable->getAt(_T("ZIGZAG"), objLTId) ;

  12.   pLTTable->close();
  13.   Acad::ErrorStatus es = acdbOpenObject((AcDbObject *&)pLTRecord, objLTId, AcDb::kForRead) ;
  14.   if(es != Acad::eOk)
  15.   {
  16.    acutPrintf(_T("ZIGZAG linetype not loaded"));
  17.         return;
  18.   }
  19.            //iterate through the linetype
  20.   int dashes = pLTRecord->numDashes();
  21.   for(int c = 0; c < dashes; c++)
  22.   {
  23.    int shpnum = pLTRecord->shapeNumberAt(c) ;
  24.    if(shpnum != 0)
  25.    {
  26.    AcDbTextStyleTableRecord *pTSRecord = NULL ;
  27.    AcDbObjectId objTSId = pLTRecord->shapeStyleAt(c);
  28.    pLTRecord->close();

  29.    acdbOpenObject((AcDbObject*&)pTSRecord,objTSId,AcDb::kForRead);
  30.    assert(pTSRecord);

  31.    const ACHAR *pName ;
  32.    Acad::ErrorStatus es = pTSRecord->fileName(pName);
  33.    pTSRecord->close();
  34.    acutPrintf(_T("\nName of shape file = %s"),pName);
  35.    }
  36.   }
  37. }


下面是.net实现代码:

Here is a VB.NET example:


  1. <CommandMethod("getShpName")> _
  2.     Public Sub GetShapeName()
  3.         Dim LtypeNames As New ArrayList()
  4.         Dim TextStyleNames As New ArrayList()
  5.         Dim db As Database = HostApplicationServices.WorkingDatabase()
  6.         Dim ed As Editor = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor
  7.         Dim tm As Transaction = db.TransactionManager.StartTransaction()
  8.         Try

  9.             Dim lineTypTbl As LinetypeTable = tm.GetObject(db.LinetypeTableId, OpenMode.ForRead)
  10.             Dim ltTblRec As LinetypeTableRecord
  11.             Dim txtStyleTblRec As TextStyleTableRecord


  12.             ltTblRec = tm.GetObject(lineTypTbl("ZigZag"), OpenMode.ForRead)


  13.             'iterate through the linetype
  14.             Dim intDashes As Integer = ltTblRec.NumDashes
  15.             Dim i As Integer
  16.             Dim iShpNum As Integer


  17.             For i = 0 To intDashes - 1
  18.                 iShpNum = ltTblRec.ShapeNumberAt(i)
  19.                 If iShpNum <> 0 Then
  20.                     Dim txtStylTblRecObjId As ObjectId = ltTblRec.ShapeStyleAt(i)
  21.                     txtStyleTblRec = tm.GetObject(txtStylTblRecObjId, OpenMode.ForRead)
  22.                     ed.WriteMessage("Name of  " & txtStyleTblRec.FileName.ToString() & vbCrLf)
  23.                 End If
  24.             Next


  25.             tm.Commit()
  26.         Catch ex As System.Exception
  27.             ed.WriteMessage(ex.ToString())


  28.         Finally
  29.             tm.Dispose()
  30.         End Try
  31.     End Sub


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-10-18 09:56 , Processed in 0.158988 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表